--forbidden
name = "penguin_omsk";
icon = "icon-omsk-right";

bounce = 0;

physic = 1;
phys_solid = 0;
phys_bullet_collidable = 1;
phys_max_x_vel = 200;
phys_max_y_vel = 50;
phys_jump_vel = 20;
phys_walk_acc = 3;
mp_count = 1;

FunctionName = "CreateEnemy";

--  

texture = "penguin_omsk";

z = -0.001;

overlay = 0;
ocolor = {1, 0, 0};
image_width = 256;
image_height = 512;

local speed = 800*((difficulty-1)/3+1);
local explosion = "explosion-safe";
if difficulty >= 2.0 then explosion = "explosion" end;

animations = 
{
	{ 
		-- 
		name = "init";
		frames = 
		{
			{ com = constants.AnimComSetHealth; param = 20*difficulty },
			{ com = constants.AnimComRealW; param = 37 },
			{ com = constants.AnimComRealH; param = 66 },
			{ com = constants.AnimComPushInt; param = 0 },
			{ com = constants.AnimComPushInt; param = 80 },
			{ com = constants.AnimComSetGravity },
			{ com = constants.AnimComSetTouchable; param = 1 },
			{ com = constants.AnimComSetAnim; txt = "idle" }	
		}
	},
	{ 
		name = "idle";
		frames = 
		{
			{ dur = 400; num = 0; com = constants.AnimComWaitForTarget; param = 3000; txt = "move" },
			{ dur = 200; num = 1; com = constants.AnimComWaitForTarget; param = 3000; txt = "move" },
			{ dur = 200; num = 2; com = constants.AnimComWaitForTarget; param = 3000; txt = "move" },
			--{ dur = 100; num = 5 },
			{ com = constants.AnimComLoop }	
		}
	},
	{ 
		-- 
		name = "pain";
		frames = 
		{
			{ com = constants.AnimComPop },
			{ com = constants.AnimComReduceHealth },
			{ com = constants.AnimComPushInt; param = 0 },
			{ com = constants.AnimComPushInt; param = 0 },
			{ com = constants.AnimComCreateParticles; txt = "pblood-wound" },
			{ com = constants.AnimComRecover }
			--{ com = constants.AnimComSetAnim; txt = "idle" }
		}
	},
	{ 
		-- 
		name = "move";
		frames = 
		{
			{ com = constants.AnimComSetAnim; txt = "jump" }
		}
	},
	{ 
		-- 
		name = "jump";
		frames = 
		{
			{ com = constants.AnimComEnemyClear; param = 600 },
			--{ dur = 0 },
			{ com = constants.AnimComPushInt; param = -64 },
			{ com = constants.AnimComJumpIfTargetY; param = 17 },
			{ com = constants.AnimComPushInt; param = 256 },
			{ com = constants.AnimComJumpIfTargetY; param = 26 },
			{ dur = 100; num = 14; com = constants.AnimComMoveToTargetX; param = speed },
			{ com = constants.AnimComSetAccY; param = -120 },
			{ dur = 100; num = 15; com = constants.AnimComMoveToTargetX; param = speed },
			{ com = constants.AnimComSetAccY; param = -180 },
			{ dur = 100; num = 16; com = constants.AnimComMoveToTargetX; param = speed },
			{ com = constants.AnimComSetAccY; param = 0 },
			{ dur = 100; num = 17; com = constants.AnimComMoveToTargetX; param = speed },
			{ dur = 100; num = 18; com = constants.AnimComMoveToTargetX; param = speed },
			{ com = constants.AnimComPushInt; param = 200 },
			{ com = constants.AnimComJumpRandom; param = 14 },
			{ com = constants.AnimComLoop },
			{ dur = 0 },
			--{ com = constants.AnimComRandomOverlayColor },
			{ com = constants.AnimComSetAnim; txt = "idle" },
			{ dur = 100; num = 14; com = constants.AnimComMoveToTargetX; param = speed },
			{ com = constants.AnimComSetAccY; param = -240 },
			{ dur = 100; num = 15; com = constants.AnimComMoveToTargetX; param = speed },
			{ com = constants.AnimComSetAccY; param = -360 },
			{ dur = 100; num = 16; com = constants.AnimComMoveToTargetX; param = speed },
			{ com = constants.AnimComSetAccY; param = 0 },
			{ com = constants.AnimComJump; param = 10 },
			{ dur = 0 },
			{ dur = 100; num = 14; com = constants.AnimComMoveToTargetX; param = -speed },
			{ com = constants.AnimComSetAccY; param = -120 },
			{ dur = 100; num = 15; com = constants.AnimComMoveToTargetX; param = -speed },
			{ com = constants.AnimComSetAccY; param = -180 },
			{ dur = 100; num = 16; com = constants.AnimComMoveToTargetX; param = -speed },
			{ com = constants.AnimComSetAccY; param = 0 },
			{ com = constants.AnimComJump; param = 10 },	
		}
	},
	{ 
		-- 
		name = "retreat";
		frames = 
		{
			{ dur = 100; num = 14; com = constants.AnimComMoveToTargetX; param = -1.5*speed },
			{ com = constants.AnimComSetAccY; param = -240 },
			{ dur = 100; num = 15; com = constants.AnimComMoveToTargetX; param = -1.5*speed },
			{ com = constants.AnimComSetAccY; param = -360 },
			{ dur = 100; num = 16; com = constants.AnimComMoveToTargetX; param = -1.5*speed },
			{ com = constants.AnimComSetAccY; param = 0 },
			{ com = constants.AnimComSetTouchable; param = 1 },
			{ com = constants.SetAnim; txt = "jump" }	
		}
	},
	{ 
		-- 
		name = "die";
		frames = 
		{
			{ com = constants.AnimComPushInt; param = 0 },
			{ com = constants.AnimComPushInt; param = 0 },
			{ com = constants.AnimComCreateEnemyBullet; txt = explosion },
			{ com = constants.AnimComPushInt; param = 0 },
			{ com = constants.AnimComPushInt; param = 8000 },
			{ com = constants.AnimComSetGravity },
			{ com = constants.AnimComSetTouchable; param = 0 },
			{ com = constants.AnimComMapVarAdd; param = 5; txt = "score" },
			{ com = constants.AnimComMapVarAdd; param = 1; txt = "kills" },
			{ num = 3; dur = 1; com = constants.AnimComRealH; param = 61 },
			{ dur = 1 },
			{ com = constants.AnimComJumpIfOnPlane; param = 13 },
			{ com = constants.AnimComJump; param = 10 },
			{ dur = 0 },
			{ num = 3; dur = 50; com = constants.AnimComRealH; param = 61 },
			{ num = 4; dur = 50; com = constants.AnimComRealH; param = 61 },
			{ num = 5; dur = 50; com = constants.AnimComRealH; param = 61 },
			{ num = 6; dur = 50; com = constants.AnimComRealH; param = 51 },
			{ num = 7; dur = 50; com = constants.AnimComRealH; param = 51 },
			{ num = 8; dur = 50; com = constants.AnimComRealH; param = 46 },
			{ num = 9; dur = 50; com = constants.AnimComRealH; param = 46 },
			{ num = 10; dur = 50; com = constants.AnimComRealH; param = 46 },
			{ num = 11; dur = 50; com = constants.AnimComRealH; param = 30 },
			{ num = 12; dur = 50; com = constants.AnimComRealH; param = 26 }
		}
	},
	{
		name = "touch";
		frames =
		{
			{ com = constants.AnimComJumpIfPlayerId; param = 3 },
			{ com = constants.AnimComSetTouchable; param = 1 },
			{ com = constants.AnimComRecover },
			{ dur = 0 },
			{ com = constants.AnimComDealDamage; param = 10*difficulty },
			{ com = constants.AnimComSetAnim; txt = "retreat" }
		}
	},
	{ 
		-- 
		name = "land";
		frames = 
		{
			{ com = constants.AnimComPushInt; param = -128 },
			{ com = constants.AnimComPushInt; param = -56 },
			{ com = constants.AnimComCreateObject; txt = "dust-land" },
			{ com = constants.AnimComSetAnim; txt = "idle" }
		}
	}
	
}



