require("serialize")

local Loader = {}
menu = require('mainmenu')

local stats = { }
stats.lives = 3
stats.scores = 0

function Loader.start()
	menu.create(Loader)
end

function Loader.gameInit()
	if not mapvar then
		mapvar = {};
	end
	if not mapvar.lives then
		mapvar.lives = stats.lives;
	end
	if not mapvar.scores then
		mapvar.scores = stats.scores;
	end

	Loader.old_time = GetCurTime()
	Loader.dt = 0
	Loader.time = 0
	Log("Init time ", Loader.time, "  old time ", Loader.old_time)
	
	SetOnPlayerDeathProcessor(Loader.onPlayerDeath)	-- ,      
end

function Loader.startGame(map_name)
	-- loading map
	waiting_for_key = 0
	godmode = 0
	Loader.map_name = map_name
	local map_script = "scripts/"..map_name..".lua"
	Log('loading game:', map_script)
	Loader.level = dofile(map_script)
	Loader.level.SetLoader(Loader)
	-- starting mission
	Loader.state = 'new'

	Loader.gameInit()	
	
	if not Loader.missionThread then 
		Loader.missionThread = NewThread( Loader.mainLoop );
		Resume(Loader.missionThread);
	end
end

function Loader.restartGame(map_name)	
		--  hiding irrelevant widgets
	Loader.game_over_widgets:show(false)
	Loader.menuShow(false)
	--Loader.exitGame(map_name)
		-- restarting game

	TogglePause();
	mn = false;
		
	Loader.level = dofile("scripts/"..Loader.map_name..".lua")
	Loader.level.SetLoader(Loader)
	
	Loader.gameInit()
end

--       new_level
function Loader.ChangeLevel(new_level)
	stats.lives = mapvar.lives;
	stats.scores = mapvar.scores;
	
	local fplr = GetPlayer(1)
	local splr = GetPlayer(2)
	
	Loader.map_name = new_level

	Loader.restartGame()
	
	if fplr then
		--Log(serialize("fplr", fplr))
		SetPlayerAltWeapon(1, fplr.altWeaponName)
		SetPlayerAmmo(1, fplr.ammo)
		SetPlayerHealth(1, fplr.health)
	end
	
	if splr then
		--Log(serialize("splr", splr))
		SetPlayerAltWeapon(2, splr.altWeaponName)
		SetPlayerAmmo(2, splr.ammo)
		SetPlayerHealth(2, splr.health)
	end
end

function Loader.exitGame(map_name)
		-- destroying all wisgets
	--Loader.mc:clear()
	MainMenu.oc:free(resume_button)
	MainMenu.oc:free(exit_button)
	MainMenu.oc:free(restart_button)
	Loader.gc:clear()
	Loader.widgetContainer:clear()
	Loader.game_over_widgets:clear()
	mn = 0
	--for i=1,10 do
	--	DestroyWidget(sndblocks[i])
	--end
	MainMenu.oc:show(false)
	if not ( mapvar == nil or mapvar.score == nil ) then
		mapvar.score = 0;
		mapvar.lives = 3;
	end
		-- leaving mission
	Loader.state = ''	--idling mainLoop thread
	DestroyGame()		-- destroying level
	menu.create(Loader)	--launching menu
end
---[[
------------------------------- ingame ui  ---------------------------------------------------
local function hideMenu()
	mn = not mn
	Loader.menuShow(mn)
	TogglePause()
end

WidgetContainer = {}
WidgetContainer.__index = WidgetContainer

function WidgetContainer.create()
	local a = {}
	setmetatable(a,WidgetContainer)
	a.ec = 0
	a.el = {}
	return a
end

function WidgetContainer:add(element)
	self.ec = self.ec + 1
	self.el[self.ec] = element
end

function WidgetContainer:clear()
	for ii=1,self.ec do
		DestroyWidget(self.el[ii])
	end
	self.ec = 0
end

function WidgetContainer:show(state)
	if (state) then
		for ii=1,self.ec do
			WidgetSetVisible(self.el[ii],true)
		end
	else
		for ii=1,self.ec do
			WidgetSetVisible(self.el[ii],false)
		end
	end
end

local function soh_btnOnLClick(sender)
	--Log('>>>> loader: soh_btnOnLClick(', sender, ')')	
	--ExitGame()
	--Loader.restartGame()
	Loader.exitGame()
	--dofile("scripts/map4.lua")
end

--Make me unsee that
	
local function showSoundBlocks(vol)
	for i=1,10 do
		if ( vol > i/10 ) then
			WidgetSetVisible(sndblocks[i], true)
		else
			WidgetSetVisible(sndblocks[i], false)
		end
	end
end
function Loader.menuShow(state)
	MainMenu.oc:show(state)
end

local function teleport_btard(x, y)
	CreateParticleSystem("pteleport", x + 164, y + 48)
	if ( math.random(40) < 10 ) then
		CreateEnemy("slowpoke", x, y)
	else
		if ( math.random(30) < 10 ) then
			CreateEnemy("btard", x, y)
		else
			if ( math.random(10) < 5 ) then
				CreateEnemy("robot", x, y)
			else
				CreateEnemy("penguin_omsk", x, y)
				CreateEnemy("penguin_omsk", x+10, y)
				CreateEnemy("penguin_omsk", x-10, y)
			end
		end
	end
end 

local function teleport_item(item, x, y)
	CreateParticleSystem("pteleport", x, y)
	CreateItem(item, x, y)
end 
local function soh_btnOnEnter(sender)
	WidgetSetAnim(sender, "aim")
end

local function soh_btnOnLeave(sender)
	WidgetSetAnim(sender, "idle")
end
------------------------------- main script game loop  ---------------------------------------------------
function Loader.mainLoop()
	while true do
		if Loader.state == 'new' then
			Loader.state = 'game'
			Loader.gameOverShown = false
			Loader.initGUI()
		elseif Loader.state == 'game' then
			Loader.btards()	-- why it's called btards?
		elseif Loader.state == 'game over' then
			Loader.showGameOver()
		elseif Loader.state == 'keyloop' then
			keyloop(Loader.sender, Loader.param)
		end
		Wait(1)
	end
end



function Loader.initGUI()	
	--   
	omb = ButtonPressed(keys.esc)
	mn = false

	local player = GetPlayer()
	
	LoadTexture("interface.png");
	LoadPrototype("gui.lua");
	LoadTexture("weapons.png");
	LoadPrototype("widget-weapons.lua");

	Loader.mc = MainMenu.oc
	Loader.gc = WidgetContainer.create()
	Loader.widgetContainer = WidgetContainer.create()
	Loader.game_over_widgets = WidgetContainer.create()

	--if not menu_altered then
		wp = CreateWidget(constants.wt_Picture, "pointer", nil, 213, 300, 10, 10)
		WidgetSetSprite(wp, "wakaba-widget")
		WidgetSetAnim(wp, "idle")
		WidgetSetVisible(wp, false)
		restart_button = CreateWidget(constants.wt_Button, "restart_button", nil, 233, 329, 70, 10)
		WidgetSetVisible(restart_button, false)
		WidgetSetCaption(restart_button, "RESTART")
		WidgetSetCaptionColor(restart_button, {1.0, 1.0, 1.0, 1.0}, false)
		WidgetSetCaptionColor(restart_button, {1.0, 0.2, 0.2, 1.0}, true)
		MainMenu.oc:add(restart_button, wp, true, nil, nil, Loader.restartGame, nil)
	
		wp = CreateWidget(constants.wt_Picture, "pointer", nil, 213, 340, 10, 10)
		WidgetSetSprite(wp, "wakaba-widget")
		WidgetSetAnim(wp, "idle")
		WidgetSetVisible(wp, false)
		resume_button = CreateWidget(constants.wt_Button, "resume_button", nil, 233, 345, 70, 10)
		WidgetSetVisible(resume_button, false)
		WidgetSetCaption(resume_button, "RESUME")
		MainMenu.oc:add(resume_button, wp, true, nil, nil, hideMenu, nil)
	
		wp = CreateWidget(constants.wt_Picture, "pointer", nil, 237, 340, 10, 10)
		WidgetSetSprite(wp, "wakaba-widget")
		WidgetSetAnim(wp, "idle")
		WidgetSetVisible(wp, false)
		exit_button = CreateWidget(constants.wt_Button, "exit_button", nil, 357, 345, 36, 10)
		WidgetSetVisible(exit_button, false)
		WidgetSetCaption(exit_button, "EXIT")
		WidgetSetCaptionColor(exit_button, {1.0, 1.0, 1.0, 1.0}, false)
		WidgetSetCaptionColor(exit_button, {1.0, 0.2, 0.2, 1.0}, true)
		MainMenu.oc:add(exit_button, wp, true, nil, nil, soh_btnOnLClick, nil)
		menu_altered = true
	--else
		--MainMenu.oc:setVisible(restart_button, true)
		--MainMenu.oc:setVisible(exit_button, true)
		--MainMenu.oc:setVisible(resume_button, true)
	--end
-------------------------------------------
	lives = {}
	for i=1,5 do
		lives[i] = CreateWidget(constants.wt_Picture, "snd"..i, nil, 66+i*16, 44, 16, 16)
		WidgetSetVisible(lives[i], false)
		WidgetSetSprite(lives[i], "gui")
		WidgetSetAnim(lives[i], "life")
		Loader.gc:add(lives[i])
	end

	local gui = CreateWidget(constants.wt_Picture, "gui", nil, 0, 0, 345, 41)
	WidgetSetSprite(gui, "gui")
	WidgetSetAnim(gui, "gui_main")
	Loader.gc:add(gui)

	local gui_score = CreateWidget(constants.wt_Picture, "gui-score", nil, 477, 0, 163, 16)
	WidgetSetSprite(gui_score, "gui")
	WidgetSetAnim(gui_score, "gui_score")
	Loader.gc:add(gui_score)

	local gui_red = CreateWidget(constants.wt_Picture, "gui-red", nil, 169, 8, 42, 25)
	WidgetSetSprite(gui_red, "gui")
	WidgetSetAnim(gui_red, "gui-red")
	Loader.widgetContainer:add(gui_red)

	gui_blue = CreateWidget(constants.wt_Picture, "gui-blue", nil, 169, 8, 161, 30)
	WidgetSetVisible(gui_blue, false)
	WidgetSetSprite(gui_blue, "gui")
	WidgetSetAnim(gui_blue, "gui-blue")
	Loader.widgetContainer:add(gui_blue)

	local time_window = CreateWidget(constants.wt_Picture, "time_window", nil, 0, 42, 78, 41)
	WidgetSetSprite(time_window, "gui")
	WidgetSetAnim(time_window, "window")
	Loader.gc:add(time_window)

	health_label = CreateWidget(constants.wt_Label, "health_label", nil, 10, 10, 65, 10)
	WidgetSetCaption(health_label, "HEALTH")
	WidgetSetCaptionColor(health_label, {1.0, 1.0, 1.0, 1.0}, false)
	Loader.gc:add(health_label)

	health = CreateWidget(constants.wt_Label, "health", nil, 30, 25, 40, 10)
	WidgetSetCaption(health, "" .. player.health)
	WidgetSetCaptionColor(health, {0.0, 1.0, 0.0, 1.0}, false)
	Loader.gc:add(health)

	local time_label = CreateWidget(constants.wt_Label, "time_label", nil, 20, 53, 40, 10)
	WidgetSetCaption(time_label, "TIME")
	WidgetSetCaptionColor(time_label, {1.0, 1.0, 1.0, 1.0}, false)
	Loader.gc:add(time_label)

	time = CreateWidget(constants.wt_Label, "time", nil, 30, 67, 35, 10)
	WidgetSetCaption(time, "0")
	WidgetSetCaptionColor(time, {1.0, 1.0, 1.0, 1.0}, false)
	Loader.gc:add(time)

	kills = CreateWidget(constants.wt_Label, "kills", nil, 492, 4, 150, 10)
	WidgetSetCaption(kills, "SCORE: 0")
	WidgetSetCaptionColor(kills, {1.0, 1.0, 1.0, 1.0}, false)
	Loader.gc:add(kills)

	bubble = nil

	ammo_label = CreateWidget(constants.wt_Label, "ammo_label", nil, 102, 10, 45, 10)
	WidgetSetCaption(ammo_label, "AMMO")
	WidgetSetCaptionColor(ammo_label, {1.0, 1.0, 1.0, 1.0}, false)
	Loader.gc:add(ammo_label)

	ammo = CreateWidget(constants.wt_Label, "ammo", nil, 110, 25, 35, 10)
	WidgetSetCaption(ammo, "100")
	WidgetSetCaptionColor(ammo, {1.0, 1.0, 1.0, 1.0}, false)
	Loader.gc:add(ammo)
	
	weapon = CreateWidget(constants.wt_Picture, "weapon", nil, 318, 9, 22, 22)
	WidgetSetSprite(weapon, "widget-weapons")
	WidgetSetAnim(weapon, "grenades")
	WidgetSetVisible(weapon, false)
	Loader.widgetContainer:add(weapon)

	--------------------------------------------------
	local lbl = CreateWidget(constants.wt_Label, "label", nil, 236, 370, 168, 10)
	--WidgetSetBorder(lbl, true)
 	WidgetSetCaption(lbl, "You are dead.")
 	--WidgetSetCaptionColor(lbl, 1.0, 0.5, 0.0, true)
 	WidgetSetCaptionColor(lbl, {1.0, 0.5, 0.0, 1.0}, false)

	local soh_btn = CreateWidget(constants.wt_Button, "soh_btn", nil, 225, 192, 178, 137)
 	--WidgetSetBorder(soh_btn, true)
 	WidgetSetSprite(soh_btn, "gui")
 	WidgetSetAnim(soh_btn, "co") 	
 	
 	WidgetSetLMouseClickProc(soh_btn, soh_btnOnLClick)
 	WidgetSetMouseEnterProc(soh_btn, soh_btnOnEnter)
 	WidgetSetMouseLeaveProc(soh_btn, soh_btnOnLeave)	
	Loader.game_over_widgets:add(lbl)
	Loader.game_over_widgets:add(soh_btn)	
	Loader.game_over_widgets:show(false)
end

function Loader.btards()
	local maxX = 1748
	local maxY = 800
	local speed = 400

	player = GetPlayer()
	hp = player.health
	Loader.level.MapScript(player)
	
	--interface update
	if ( hp < 50 ) then
		if ( hp < 25 ) then
			WidgetSetCaptionColor(health, {1.0, 0.0, 0.0, 1.0}, false)
		else
			WidgetSetCaptionColor(health, {1.0, 0.5, 0.0, 1.0}, false)
		end
	else
		WidgetSetCaptionColor(health, {0.0, 1.0, 0.0, 1.0}, false)
	end
	WidgetSetCaption(health, "" .. hp)
	WidgetSetCaption(time, "" .. math.floor(Loader.time / 1000))
	if godmode > 0 then
		godmode = godmode - 1
		if godmode == 0 then
			SetObjInvincible(inv, false)
		end
	end
	if godmode < 0 then
		SetObjInvincible(inv, false)
		godmode = 0
	end
	WidgetSetCaption(ammo, "" .. player.ammo)
	if ( waiting_for_key == 1 ) then
		key = GetFirstButtonPressed()
		if (key ~= null ) then
			CONFIG[wpar.button] = key
			LoadConfig()
			WidgetSetCaption(wsender, wpar.caption.." : "..GetKeyName(key))
			DestroyWidget(prompt_bkg)
			DestroyWidget(prompt)
			MainMenu.oc:show(true)
			SaveConfig()
		end
	end
	if ( player.altWeaponName == "none" ) then
		old_weapon = "none"
		WidgetSetVisible(weapon, false)
	else
		if ( player.altWeaponName == "grenade" and old_weapon~= "grenade" ) then
			old_weapon = "grenade"
			WidgetSetAnim(weapon, "grenades")
			WidgetSetVisible(weapon, true)
		end
		if ( player.altWeaponName == "flamer" and old_weapon~= "flamer" ) then
			old_weapon = "flamer"
			WidgetSetAnim(weapon, "flamer")
			WidgetSetVisible(weapon, true)
		end
		if ( player.altWeaponName == "spread" and old_weapon~= "spread" ) then
			old_weapon = "spread"
			WidgetSetAnim(weapon, "spread")
			WidgetSetVisible(weapon, true)
		end
		if ( player.altWeaponName == "rapid" and old_weapon~= "rapid" ) then
			old_weapon = "rapid"
			WidgetSetAnim(weapon, "machinegun")
			WidgetSetVisible(weapon, true)
		end
		if ( player.altWeaponName == "rocketlauncher" and old_weapon~= "rocket" ) then
			old_weapon = "rocket"
			WidgetSetAnim(weapon, "rocketlauncher")
			WidgetSetVisible(weapon, true)
		end
	end
	if ( player.altWeaponActive ) then
		WidgetSetVisible(gui_blue, true)
		WidgetSetCaptionColor(ammo_label, {1.0, 1.0, 1.0, 1.0}, false)
		WidgetSetCaptionColor(ammo, {1.0, 1.0, 1.0, 1.0}, false)
	else
		WidgetSetVisible(gui_blue, false)
		WidgetSetCaptionColor(ammo_label, {0.5, 0.5, 0.5, 1.0}, false)
		WidgetSetCaptionColor(ammo, {0.5, 0.5, 0.5, 1.0}, false)
	end
	if ( mapvar == nil or mapvar.score == nil ) then
		WidgetSetCaption(kills, "SCORE: 0")
	else
		WidgetSetCaption(kills, "SCORE: " .. mapvar.score)
	end

	if ( mapvar ~= nil and mapvar.lives ~= nil ) then
		if (mapvar.lives >=  6) then 
			showlives = 5
		else
			showlives = mapvar.lives-1
		end
		for i=1,showlives do
			if lives[i] then WidgetSetVisible(lives[i], true) end
		end
		for i=showlives+1,5 do
			if lives[i] then WidgetSetVisible(lives[i], false) end
		end
	end

	
	if hp > 0 then
		screen = GetScreenInfo()

		--player = GetPlayer()
		--[[
		if ( player.isInvincible and bubble == nil ) then
			bubble = CreateWidget(constants.wt_Picture, "invincibility-bubble", nil, 256, 221, 384, 349)
			WidgetSetVisible(bubble, true)
 			WidgetSetSprite(bubble, "invincibility-bubble")
		end
		--]]
		if ( waiting_for_key == 1 ) then
			
		end
		if ( (not omb) and ButtonPressed(keys.esc) ) then
			mn = not mn
			TogglePause()
			Loader.menuShow(mn)
		end
		omb = ButtonPressed(keys.esc)
		if not ( player.isInvincible or bubble == nil ) then
			DestroyWidget( bubble )
			bubble = nil
		end
		
		
		local t = GetCurTime()
		if not ( GamePaused() ) then 
			Loader.dt = t - Loader.old_time
			Loader.time = Loader.time + Loader.dt
		end
		Loader.old_time = t

		--[[
		if ( old_t ~= t and speed > 100 ) then
			old_t = t
			speed = speed - 10
		end
		--]]
	else
		--Loader.state = 'game over'
	end
end

function Loader.showGameOver()
	if Loader.gameOverShown then return end
	Loader.gameOverShown = true
	if bubble then
		DestroyWidget(bubble)
	end
	--Loader:btards() --one last time
	LoadSound("music\\iie_finish.it")
	StopBackMusic()
	PlaySnd("iie_finish", true)
	Loader.game_over_widgets:show(true)
end

-- ,   ,     ,   GetPlayer   
-- old_plr_info -      . num -   (1  2)
function Loader.onPlayerDeath(old_plr_info, num)
	mapvar.lives = mapvar.lives - 1
	if mapvar.lives > 0 then
		--  ,     
		--SetPlayerRevivePoint(60 + math.random(2000), -100 + math.random(100));	
		-- RevivePlayer( ,  ) 
		--Log(serialize("plr_info", old_plr_info))
		local plr_id = RevivePlayer(num, nil);
		SetCamAttachedObj(plr_id)
		--     
		SetPlayerAltWeapon(num, old_plr_info.altWeaponName)
		SetPlayerAmmo(num, old_plr_info.ammo)
		SetObjInvincible(num, true)
		godmode = 100
		inv = num
	else
		Loader.state = 'game over'
		--Log("final death")
	end
end



--]]
return Loader
